import * as React from "react";
export interface ProgressElement {
    value: number;
    color: string;
    showPercentage?: boolean;
    textColor?: string;
    fontSize?: number;
    className?: string;
}
export declare type ProgressComponentProps<T> = {
    children?: React.ReactNode;
    className?: string;
    element: (ProgressElement & T);
} & Record<string, unknown>;
export declare type IMultiProgressProps<T> = {
    backgroundColor?: string;
    border?: string;
    elements: (ProgressElement & T)[];
    height?: number | string;
    round?: boolean;
    roundLastElement?: boolean;
    transitionTime?: number;
    className?: string;
    component?: React.ElementType<ProgressComponentProps<T>>;
};
export default function MultiProgress<T = Record<string, never>>({ backgroundColor, border, elements, height, round, roundLastElement, transitionTime, className, component }: IMultiProgressProps<T>): JSX.Element;
